/**
 * DiCloud - GENI project
 * 
 * (C) 2010 - University of Massachusetts Amherst
 * 
 * Initial developer(s): Emmanuel Cecchet.
 * Contributor(s): ______________________.
 */
package edu.umass.cs.geni.ec2;

/**
 * This class defines the properties specific to Amazon Web Services (AWS)
 * 
 * @author <a href="mailto:cecchet@cs.umass.edu">Emmanuel Cecchet </a>
 * @version 1.0
 * 
 */
public final class AmazonProperties
{

  /**
   * Location of the Amazon AWS X.509 certificate file (cert-xxx.pem)
   */
  public static final String AWS_CERT_FILE         = "aws.cert.file";

  /**
   * Location of the Amazon AWS private key file (pk-xxx.pem)
   */
  public static final String AWS_PRIVATE_KEY_FILE  = "aws.pk.file";

  /**
   * Identifier of the Amazon Image (AMI)
   */
  public static final String EC2_AMI_ID            = "ec2.ami.id";

  /**
   * Identifier of a running Amazon instance
   */
  public static final String EC2_INSTANCE_ID       = "ec2.instance.id";

  /**
   * Number of instances to create
   */
  public static final String EC2_INSTANCE_NUMBER   = "ec2.instance.number";

  /**
   * EC2 Instance type. Currently available values (Jan 2009) are: m1.small |
   * m1.large | m1.xlarge | c1.medium | c1.xlarge | m2.2xlarge | m2.4xlarge
   */
  public static final String EC2_INSTANCE_TYPE     = "ec2.instance.type";

  /**
   * Current instance state as reported by ec2-describe-instances
   */
  public static final String EC2_INSTANCE_STATE    = "ec2.instance.state";

  /**
   * Time at which the instance was started
   */
  public static final String EC2_START_TIME        = "ec2.start.time";

  /**
   * Region in which instances are created (run 'ec2-describe-regions' for a
   * list)
   */
  public static final String EC2_REGION            = "ec2.region";

  /**
   * Availability zone in which instances are created (run
   * 'ec2-describe-availability-zones' for a list)
   */
  public static final String EC2_AVAILABILITY_ZONE = "ec2.availability.zone";

  /**
   * Key pair name that has been registered with ec2-add-keypair
   */
  public static final String EC2_KEY_PAIR_NAME     = "ec2.key.pair.name";

  /**
   * Key pair that has been generated with ec2-add-keypair
   */
  public static final String EC2_KEY_PAIR          = "ec2.key.pair";

  /**
   * Public name of an EC2 instance (registered in DNS)
   */
  public static final String EC2_PUBLIC_NAME       = "ec2.public.name";

  /**
   * Private name of an EC2 instance (only accessible within EC2)
   */
  public static final String EC2_PRIVATE_NAME      = "ec2.private.name";

  /**
   * Public IP of an EC2 instance (registered in DNS)
   */
  public static final String EC2_PUBLIC_IP         = "ec2.public.ip";

  /**
   * Private IP of an EC2 instance (only accessible within EC2)
   */
  public static final String EC2_PRIVATE_IP        = "ec2.private.ip";

  /**
   * Size of an EBS volume in GB
   */
  public static final String EBS_SIZE_IN_GB        = "ebs.size";

  /**
   * Id of an EBS volume that has been created
   */
  public static final String EBS_VOLUME_ID         = "ebs.volume.id";

  /**
   * Status of an EBS volume (creating, available...)
   */
  public static final String EBS_STATUS            = "ebs.status";

  /**
   * Creation time of an EBS volume
   */
  public static final String EBS_CREATION_TIME     = "ebs.creation.time";

  /**
   * S3 bucket name
   */
  public static final String S3_BUCKET_NAME        = "s3.bucket.name";

  /**
   * S3 Location (none for standard US, us-west-1 or EU)
   */
  public static final String S3_LOCATION           = "s3.location";
}
