/**
 * DiCloud - GENI project
 * 
 * (C) 2010 - University of Massachusetts Amherst
 * 
 * Initial developer(s): Emmanuel Cecchet.
 * Contributor(s): ______________________.
 */

package edu.umass.cs.geni.ec2.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.rmi.Naming;

import edu.umass.cs.geni.ec2.accounting.S3ProxyInterface;

/**
 * TODO: Def here
 * 
 * @author <a href="mailto:cecchet@cs.umass.edu">Emmanuel Cecchet </a>
 * @version 1.0
 * 
 */
public class S3ClientTest
{
  /**
   * @param args
   *          1. proxy url, 2. put/get, 3. filename
   */
  public static void main(String[] args)
  {
	try
	{
	  if (args.length != 3)
	  {
		System.err
		    .println("Usage: \n"
		        + "java -cp dicloud-orca.jar edu.umass.cs.geni.ec2.test.S3ClientTest //localhost/geni-dicloud-gec8demo PUT filename.nc"
		        + "java -cp dicloud-orca.jar edu.umass.cs.geni.ec2.test.S3ClientTest //localhost/geni-dicloud-gec8demo GET filename.png");
		System.exit(-1);
	  }
	  String proxyUrl = args[0];
	  S3ProxyInterface s3Proxy = (S3ProxyInterface) Naming.lookup(proxyUrl);

	  byte[] data;
	  if ("PUT".equalsIgnoreCase(args[1]))
	  {
		System.out.println("Putting file " + args[2]);
		File f = new File(args[2]);
		int size = (int) f.length();
		data = new byte[size];
		FileInputStream fis = new FileInputStream(f);
		fis.read(data);
		fis.close();
		s3Proxy.put(args[2], data);
	  }
	  else
	  {
		System.out.println("Getting file " + args[2]);
		data = s3Proxy.get(args[2]);
		File f = new File(args[2]);
		f.createNewFile();
		// if a file with that name already exists, it wil fail here
		FileOutputStream fos = new FileOutputStream(f);
		fos.write(data);
		fos.close();
	  }
	}
	catch (Exception e)
	{
	  System.err.println("Failed with exception: " + e);
	  e.printStackTrace();
	}
  }

}
